# by plushpuffin@wwddfd.com
# http://www.wwddfd.com
# ModGrep Addon
push(@Addons_Loaded, 'News Modify Grep 2.0');
push(@Addons_NPHTMLHead, 'ModGrepHead');
push(@Addons_PageHandler, 'ModGrepPageHandler');
push(@Addons_RemoveNews, 'ModGrepRemoveNews');
$Addons_List{'News Modify Grep 2.0'} = ['npa_modgrep.pl', 'Allows regular expression searches of newsdat.txt for modification'];


sub ModGrepPageHandler {
	if( $qstring eq 'help/regexp' ) {
		$HeaderPrinted = 1;
		&NPHTMLHead('Regular Expressions');
		print qq~<div align="center" style="font-size:2em"><a href="http://hotwired.lycos.com/webmonkey/97/33/index3a.html?tw=programming">Visit Webmonkey's Regular Expression tutorial</a><br>
		<br><br>ModGrep written by <a href="mailto:plushpuffin\@wwddfd.com">plushpuffin</a><br>
		<a href="http://www.wwddfd.com">plushpuffin's perl garden</a><br><br>
		</div>~;
		&NPHTMLFoot;
		exit;
	}
}

sub ModGrepdoIt {
	$searchData = ${$fldgrep};
	$txtgrep =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
	if( $useregexp ) {
		if ( ($searchData =~ m~$txtgrep~i ) ) {
			return 1;
		}
	}
	else {
	        if ( ($searchData =~ m~\Q$txtgrep~i ) ) {
                        return 1;
                }
	}
	return 0;
}

sub ModGrepInsideHook {
	if( $txtgrep eq '' ) { return 1; }
	$modmatches = 0;
	if( $fldgrep eq 'all' ) {
		foreach $fldgrep (@ffeel) {
			$modmatches = &ModGrepdoIt();
			if( $modmatches ) { last; }
		}
	}
	else {
		$modmatches = &ModGrepdoIt();
	}
	return $modmatches;
}

sub ModGrepRemoveNews {
	my $nncount = 0;
	my $i;
	while( @Addons_RemoveNews ) {
		if( $Addons_RemoveNews[0] eq "ModGrepRemoveNews" ) {
			shift @Addons_RemoveNews;
			last;
		}
		shift @Addons_RemoveNews;
	}
	if (@Addons_RemoveNews) {
		&RunAddons(@Addons_RemoveNews);
	}
	MDFYLOOP: while (($nncount < $NPConfig{'Modify_ItemsPerPage'}) && ($newsnum >= 0))
	{
		getNDvar($newsnum);
		if( ! &ModGrepInsideHook() ) { $newsnum--; next MDFYLOOP; }
		if ($up >= 2 || $newsname eq $Cookies{'uname'}) {
			print qq~
			$Messages{'Modify_Posted'} $newsdate $Messages{'Modify_By'} $newsname.~;
			if (@Addons_RemoveNews2) {
				&RunAddons(@Addons_RemoveNews2);
			}
			print '<br>';
			foreach $i (@formfields) {
				unless ($DisableModify{$i} == 1) {
					if ($up > 1 || $DisableModify{$i} != 2) {
						if ($FormFieldsName{$i}) {
							print $FormFieldsName{$i};
						} else {
							print $i;
						}
						$escapedfield = &HTMLescape(${$i});
						if ($FormFieldsModifySize{$i}) {
							if ($FormFieldsNewlines{$i}) {
								$escapedfield =~ s/\&lt;br\&gt;/\n/gi;
							}
							print qq~ <textarea name="$i--$newsnum" wrap="virtual" cols="70" rows="7" wrap="virtual">$escapedfield</textarea> ~;
						}
						else {
							print qq~: <input type="text" name="$i--$newsnum" value="$escapedfield" size="40"><br>~;
						}
					}
				}
			}
			$escapedfield = $newstext;
			$escapedfield =~ s/<br>/\n/gi;
			$escapedfield = &HTMLescape($escapedfield);
			print qq~
<textarea name="newstext--$newsnum" cols="70" rows="8" wrap="virtual">$escapedfield</textarea><br>
$Messages{'Modify_Keep'} <input type=radio name="chk--$newsnum" value="keep" checked>&nbsp;&nbsp;
$Messages{'Modify_Remove'} <input type=radio name="chk--$newsnum" value="remove"> <hr>
	~;
			$nncount++;
		} 
		$newsnum--;
	}
	if( $newsnum < 0 ) {
		print qq~<div align="center"><b>Search reached end of articles.</b>~;
	}
	if ($nncount == 0 && $newsnum != 0) {
		print qq~</form><div align="center"><b>You do not have permission to modify any news items.</b>~;
	}
	else {
		print qq~<div align="center"><input type=hidden name=ndage value="$nd_age">~;
		unless ($newsnum < 0) {
			print qq~
			$Messages{'Modify_Save'} $Messages{'And'}<input type="submit" name="finishmodifying" value="$Messages{'Modify_Finish'}"> $Messages{'Modify_Or'} 
			<input type="hidden" name="shownextnum" value="$newsnum">
			<input type="submit" name="shownext" value="$Messages{'Modify_Show'} $NPConfig{'Modify_ItemsPerPage'} $Messages{'Modify_Items'}">.
			~;
		} 
		else {
			print qq~
			<input type="submit" name="finishmodifying" value="$Messages{'Modify_Save'}">
			~;
		}
	}
	print "</div>";
	&NPHTMLFoot;
	exit 0;
}

sub ModGrepHead {
	&SubmitFormFields();
	if( $qstring !~ /remove/ ) { return; }
	$FormFieldsName{'newstext'} = 'News Text';
	$FormFieldsName{'newscat'} = 'News Category';
	$FormFieldsName{'all'} = 'All Fields';
	push(@ffeel, 'newstext');
	push(@ffeel, 'newscat');
	push(@ffeel, @formfields);
	@ffopt = ( 'all' );
	push(@ffopt, @ffeel);
	$nilorthat = '';
	if( $in{'searchstring'} ) {
		$txtgrep = $in{'searchstring'};
		$fldgrep = $in{'searchfield'};
		$useregexp = $in{'useregexp'};
	}
	else {
		$txtgrep = '';
		$fldgrep = 'all';
		$useregexp = 0;
	}
	if( $useregexp ) {
		$urech = 'checked';
	}
	print qq~<center><table bgcolor="darkblue"><tr><td colspan="2">
<form action="$scripturl?remove" method="post">
	<input type="text" name="searchstring" value="$txtgrep" size="40"></td></tr><tr><td align="center">
	ModGrep: <select name="searchfield">~;
	my ($i, $fname);
	foreach $i (@ffopt) {
		$fname = $FormFieldsName{$i} || $i;
		print qq~<option value="$i"~;
		if( $i eq $fldgrep ) { print qq~ selected~; }
		print qq~>$fname</option>~;
	}
	print qq~
	</select>
	<input type="submit" name="submit" value="Submit"></td>
	<td><input type="checkbox" name="useregexp" value=1 $urech>use regexp
	&nbsp <a href="$scripturl?help/regexp">help</a></td></tr>
	</form></table></center><br>~;
}
1;
